---
title: Window.sessionStorage
slug: Web/API/Window/sessionStorage
tags:
  - APIs
  - Property
  - Reference
  - Storage
  - Window
  - WindowSessionStorage
  - sessionStorage
---
<p>{{APIRef("Web Storage API")}}</p>

<p><span class="seoSummary">The read-only <strong><code>sessionStorage</code></strong> property accesses a session {{DOMxRef("Storage")}} object for the current {{glossary("origin")}}. <code>sessionStorage</code> is similar to {{DOMxRef("Window.localStorage", "localStorage")}}; the difference is that while data in <code>localStorage</code> doesn't expire, data in <code>sessionStorage</code> is cleared when the <em>page session</em> ends.</span></p>

<ul>
 <li>Whenever a document is loaded in a particular tab in the browser, a unique page session gets created and assigned to that particular tab. That page session is valid only for that particular tab.</li>
 <li>A page session lasts as long as the tab or the browser is open, and survives over page reloads and restores.</li>
 <li><strong>Opening a page in a new tab or window creates a new session with the value of the top-level browsing context, which differs from how session cookies work.</strong></li>
 <li>Opening multiple tabs/windows with the same URL creates <code>sessionStorage</code> for each tab/window.</li>
 <li>Closing a tab/window ends the session and clears objects in <code>sessionStorage</code>.</li>
</ul>

<p>Data stored in <code>sessionStorage</code> <strong>is specific to the protocol of the page</strong>. In particular, data stored by a script on a site accessed with HTTP (e.g., <a href="http://example.com" rel="freelink noopener">http://example.com</a>) is put in a different <code>sessionStorage</code> object from the same site accessed with HTTPS (e.g., <a href="https://example.com" rel="freelink noopener">https://example.com</a>).</p>

<p>The keys and the values are <em>always</em><strong> </strong>in the UTF-16 {{domxref("DOMString")}} format, which uses two bytes per character. As with objects, integer keys are automatically converted to strings.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>myStorage</em> = <em>window</em>.sessionStorage;
</pre>

<h3 id="Value">Value</h3>

<p>A {{DOMxRef("Storage")}} object which can be used to access the current origin's session storage space.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>SecurityError</code></dt>
 <dd>The request violates a policy decision, or the origin is not <a href="/en-US/docs/Web/Security/Same-origin_policy#Definition_of_an_origin">a valid scheme/host/port tuple</a> (this can happen if the origin uses the <code>file:</code> or <code>data:</code> scheme, for example). For example, the user may have their browser configured to deny permission to persist data for the specified origin.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_usage">Basic usage</h3>

<pre class="brush: js notranslate">// Save data to sessionStorage
sessionStorage.setItem('key', 'value');

// Get saved data from sessionStorage
let data = sessionStorage.getItem('key');

// Remove saved data from sessionStorage
sessionStorage.removeItem('key');

// Remove all saved data from sessionStorage
sessionStorage.clear();</pre>

<h3 id="Saving_text_between_refreshes">Saving text between refreshes</h3>

<p>The following example autosaves the contents of a text field, and if the browser is refreshed, restores the text field content so that no writing is lost.</p>

<pre class="brush: js; notranslate">// Get the text field that we're going to track
let field = document.getElementById("field");

// See if we have an autosave value
// (this will only happen if the page is accidentally refreshed)
if (sessionStorage.getItem("autosave")) {
  // Restore the contents of the text field
  field.value = sessionStorage.getItem("autosave");
}

// Listen for changes in the text field
field.addEventListener("change", function() {
  // And save the results into the session storage object
  sessionStorage.setItem("autosave", field.value);
});</pre>

<div class="notecard note">
<p><strong>Note</strong>: Please refer to the <a href="/en-US/docs/Web/API/Web_Storage_API/Using_the_Web_Storage_API">Using the Web Storage API</a> article for a full example.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "webstorage.html#dom-sessionstorage", "sessionStorage")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.sessionStorage")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Storage_API/Using_the_Web_Storage_API">Using the Web Storage API</a></li>
 <li>{{DOMxRef("Window.localStorage")}}</li>
</ul>
